// (c) copyright 2004-2005 Research Solutions and Resources.
//     All rights reserved.
var oops = 0;

function getDUnit (aForm) { // returns conversion to cm
	var DU = parseInt(aForm.DUnit.selectedIndex);
	DU = parseFloat(aForm.DUnit.options[DU].value);
	return DU;
}
function getLUnit (aForm) { // returns conversion to cm
	var LU = parseInt(aForm.LUnit.selectedIndex);
	LU = parseFloat(aForm.LUnit.options[LU].value);
	return LU;
}
function getWireD (aForm) { // returns entered diameter in cm
	var Dreturn = -99;
	var Dvalid = -2;
	var D = parseFloat(aForm.WireD.value);
 	if (D<=0)  {Dvalid=-1;};
	if (D>0)   {Dvalid=1;};
	switch(Dvalid)
	{
		case -1:
			alert("Zero or Negative Diameter !");
			oops=1;
			break;
		case 1:
			Dreturn = D * getDUnit(aForm);
			break;
		default:
			alert("No Diameter Entered ! !");
			oops=1;
	};
	if (Dvalid<0) {
		aForm.WireD.value = "RE-ENTER!";
	};
	return Dreturn;
}
function getWireL (aForm) { // returns entered length in cm

	var Lreturn = -99;
	var Lvalid = -2;
	var L = parseFloat(aForm.WireL.value);
 	if (L<=0)  {Lvalid=-1;};
	if (L>0)   {Lvalid=1;};
	switch(Lvalid)
	{
		case -1:
			alert("Zero or Negative Length !");
			oops=1;
			break;
		case 1:
			Lreturn = L * getLUnit(aForm);
			break;
		default:
			alert("No Length Entered ! !");
			oops=1;
	};
	if (Lvalid<0) {
		aForm.WireL.value = "RE-ENTER!";
	};
	return Lreturn;
}

function getWirePerm (aForm) { // returns entered permeability
	var Preturn = -99;
	var Pvalid = -2;
	var P = parseFloat(aForm.WirePerm.value);
 	if (P<=0)  {Pvalid=-1;};
	if (P>0)   {Pvalid=1;};
	switch(Pvalid)
	{
		case -1:
			alert("Zero or Negative Permeability !");
			oops=1;
			break;
		case 1:	
			Preturn=P;
			break;
		default:
			alert("No Permeability Entered ! !");
			oops=1;
	};
	if (Pvalid<0) {
		aForm.WirePerm.value = "RE-ENTER!";
	};
	return Preturn;
}

function calculate( aForm ) {
	var WL = -1;
	var WD = -1;
	var WU = -1;
	oops = 0;
	WL = getWireL(aForm);
	WD = getWireD(aForm);
	WU = getWirePerm(aForm);
	if (oops>0)
		{aForm.nanoHenry.value = "ERRORS!";}
	else {
		var L2 = 2.0*WL;
		var U = 1;
		var tmp = WD/L2;	// =D/(2*Length)
		var tmp2 =Math.sqrt(1.0+tmp*tmp);
//		L = L2*(Math.log(2.0*tmp) + WU/4.0 - 1.0 +1.0/tmp);	//
		var L = L2*(Math.log((1.0+tmp2)/tmp)+WU/4.0-tmp2+tmp);
		aForm.nanoHenry.value =  L ;
		};
}
